function [x,iter] = g_seidel ( A, b, x0, TOL, Nmax )

%GAUSS_SEIDEL approximate the solution of the linear system Ax = b by applying
%             the Gauss-Seidel method (successive relaxation)

[n,n]=size(A); iter=0;
r=b-A*x0;
r0=norm(r);
normb=norm(b);
err=norm(r)/normb;

x=x0;
while err>TOL & iter<Nmax
    iter=iter+1;
    for i=1:n
        s=A(i,1:i-1)*x(1:i-1);
        s=s+A(i,i+1:n)*x(i+1:n);
        x(i)=(b(i)-s)/A(i,i);
    end
    
    r=b-A*x;
    err=norm(r)/normb;
end
